<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>Chatbot web interface</title>
<!--<link rel="stylesheet" href="style.css">-->
<script type="text/javascript">

// TTS from madrigal
var ttsVoice = null;
var tts = window.speechSynthesis;

function getTTSVoice(){
        var voices = window.speechSynthesis.getVoices();
        var enVoices = voices.filter(function(voice){ return voice.lang.startsWith('en') });
        var bestVoice = voices.filter(function(voice){ return voice.name == 'Google UK English Female' });
        return bestVoice.length > 0 ? bestVoice[0] : enVoices[0];
}

tts.onvoiceschanged = function(){ ttsVoice = getTTSVoice() };

function getEl(id) { return document.getElementById(id) };

// https://plainjs.com/javascript/ajax/send-ajax-get-and-post-requests-47/
function post_ajax(url, data, success, failure) {

    var xhr = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");
    xhr.open('POST', url);
    xhr.onreadystatechange = function() {
        if (xhr.readyState > 3){
            if (xhr.status == 200){
                success(xhr.responseText);
            }
            else {
                failure(xhr.status);
            }
        }
    };
    xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
    xhr.setRequestHeader('Content-Type', 'application/json; charset=utf-8');
    xhr.send(JSON.stringify(data));
    return xhr;
}

function send_user_input(){
    var input = getEl('user_input');
    var outputs = getEl('outputs');

    input.disabled = 'disabled';
    outputs.innerHTML += 'User: ' + input.value + '<br/>';
    post_ajax(window.location.href + '/request',
        {'user': input.value},
        function(data){ show_system_response(data) },
        function(status){ show_error(status) }
    );
    input.value = '(waiting for system)';
}

function show_system_response(data){
    var input = getEl('user_input');
    var outputs = getEl('outputs');

    data = JSON.parse(data);
    outputs.innerHTML += 'System: ' + data['system'] + '<br/><br/>';
    input.value = '';
    input.disabled = '';
    input.focus();
}

function show_error(status){
    var outputs = getEl('outputs');

    outputs.innerHTML += '<span style="color: red;">The chatbot server is currently unavailable (error code: ' + status + '). Please try again later.<br/><br/>';
}

function process_button_click(){
    var button = getEl('button');
    var input = getEl('user_input');
    var outputs = getEl('outputs');

    if (button.innerHTML == 'Start dialogue'){
        post_ajax(window.location.href + '/request',
            {'start_session': 1},
            function(data){
                if (outputs.innerHTML){
                    outputs.innerHTML += '<br/>***<br/>';
                }
                show_system_response(data);
                button.innerHTML = 'End dialogue';
            },
            function(status){ show_error(status) }
        );
        input.value = '(waiting for system)';
    }
    else {
        post_ajax(window.location.href + '/request',
            {'end_session': 1},
            function(data){ show_system_response(data); input.disabled = 'disabled'; },
            function(status){ show_error(status) }
        );
        input.value = '(waiting for system)';
        button.innerHTML = 'Start dialogue';
    }
}

</script>
</head>
<body>
<h1>Alex – testovací rozhraní</h1>
<div id="descr" style="margin-bottom: 2em; color: gray;">
<ul>
<li>Začněte kliknutním na „Start dialogue“. </li>
<li>Zadávejte český text <strong>s diakritikou</strong> (na velikosti písmen nezáleží), odešlete klávesou Enter.</li>
<li>Po skončení dialogu klikněte na „End dialogue“.</li>
<li>Systém umí obsloužit max. 2 uživatele najednou.</li>
</ul>
<p>
Příklady zadání: <em>„chci jet z Prahy do Brna“, „z Malostranské na Anděl“, „chci jet tramvají“, „kolik to má přestupů“, „chci jet zítra v pět hodin“, „další spojení“</em>
</p>
</div>
<div id="outputs"></div>
<form action="javascript:void(0);" onsubmit="send_user_input();" style="margin-top: 1em;">
<button type="button" onclick="process_button_click();" id="button">Start dialogue</button><br/>
Enter user input: <input type="text" id="user_input" maxlength="200" style="width: 30em;" autocomplete="off" disabled="disabled" value="(click 'Start dialogue' to start)">
</form>
</body>
</html>
